﻿<?xml version="1.0" encoding="utf-8"?>
<html xmlns:MadCap="http://www.madcapsoftware.com/Schemas/MadCap.xsd">
    <head>
        <link href="../Resources/TableStyles/Default-Table.css" rel="stylesheet" MadCap:stylesheetType="table" /><title>Creating Runtime Analytics Controls</title>
        <link href="../Resources/Stylesheets/Styles.css" rel="stylesheet" type="text/css" />
    </head>
    <body>
        <h1>Creating Runtime Analytics Controls</h1>
        <p>You can create runtime analytics using the <strong>Create New Analytics Configuration</strong>. A runtime analytics will be necessary to evaluate and send out a report during real-time application processing. There are two primary uses of runtime analytical control. Firstly, it is used to fetch the data at the particular instance, which is runtime report and display the data. If you just want to display the runtime data, you need to select Executable Type = Executable. For example, while critical application is running and someone tries to delete a file, immediately a reporting mail must be triggered and the concerned owner must be reported about this event. This has to happen while the application is still running. Such tasks/events need to be reported on the go, so we can configure the runtime analytics.&#160;</p>
        <p>Secondly, runtime analytic control is used in conjunction with <MadCap:xref href="../Chapter05-Managing-Policies/Creating-Entitlement-Update-Rules.htm">Creating Entitlement Update Rules</MadCap:xref>. The runtime analytical control (Non-Elasticsearch) of Executable Type = Preventative is linked and selected in Entitlement Update Rule. The query to fetch the data for a particular entitlement is specified in runtime analytical control.</p>
        <ol>
            <li>Go to <strong>Analytics &gt; Analytics Configuration List.</strong></li>
            <li>
                <p>Select the Version 1 tab.</p>
            </li>
            <li>
                <p>Click <strong>Create New Analytics</strong>.</p>
            </li>
            <li>
                <p>Select RUNTIME ANALYTICS&#160;and&#160;click <strong>Create</strong>.</p>
                <p>Before creating the analytics control, there is an option to <strong>Preview</strong> the control configuration, towards the end of the <strong>Create New Analytics Configuration </strong>page.</p>
            </li>
            <li>
                <div class="confluence-information-macro confluence-information-macro-information conf-macro output-block">
                    <div class="confluence-information-macro-body">
                        <p>Note the following points related to <strong>Preview</strong> and <strong>Create</strong> buttons:</p>
                        <ul>
                            <li>If the SQL query that you entered in the control configuration, returns more than or equal to ten records, then the analytics preview displays all the ten records. If the query returns less than ten records, the preview displays those many numbers of records.</li>
                            <li>The <strong>Preview</strong> button is enabled before you click the <strong> Create</strong> button. Once the analytics control is created, you cannot view the <strong>Preview</strong> button.</li>
                            <li>The <strong>Preview</strong> button is used to validate the correctness of the query syntax and to display the first 10 rows of the result data. This does not validate columns in the analytics query for the allowed action. An error message is displayed if the query syntax is incorrect. You can view the error details from the log files or by executing the same query directly in the database.</li>
                            <li>The <strong>Create</strong> button must be used as the final step in the creation of the analytics control. This validates the mandatory columns in the analytics query for the allowed action. You will be able to select the visible and filterable columns for the control and submit the control creation only if all validations are complete.</li>
                        </ul>
                    </div>
                </div>
            </li>
            <li>
                <p class="auto-cursor-target">Enter/select the appropriate values in the following parameters.</p>
                <div class="table-wrap">
                    <table class="TableStyle-Default-Table" style="width: 100%;mc-table-style: url('../Resources/TableStyles/Default-Table.css');" cellspacing="0">
                        <col style="width: 140.0px;" class="TableStyle-Default-Table-Column-Column1" />
                        <col style="width: 440.0px;" class="TableStyle-Default-Table-Column-Column1" />
                        <thead>
                            <tr class="TableStyle-Default-Table-Head-Header1">
                                <th class="TableStyle-Default-Table-HeadE-Column1-Header1">Parameter</th>
                                <th class="TableStyle-Default-Table-HeadD-Column1-Header1">Description</th>
                            </tr>
                        </thead>
                        <tbody>
                            <tr class="TableStyle-Default-Table-Body-Body1">
                                <td style="text-align: left;" class="TableStyle-Default-Table-BodyE-Column1-Body1">
                                    <p class="table-text">Analytics Name<span style="color: rgb(255,0,0);">*</span></p>
                                </td>
                                <td style="text-align: left;" class="TableStyle-Default-Table-BodyD-Column1-Body1">
                                    <p class="table-text">Enter the appropriate analytics name.</p>
                                    <p class="table-text">This is a free-text-entry field. The analytics name must be unique and system will not allow you to create multiple analytics with the same name.</p>
                                </td>
                            </tr>
                            <tr class="TableStyle-Default-Table-Body-Body1">
                                <td colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1">
                                    <p class="table-text">Status</p>
                                </td>
                                <td colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1">
                                    <p style="text-align: left;" class="table-text">Select the current status of the analytics.</p>
                                    <p style="text-align: left;" class="table-text">The following options are available to select:</p>
                                    <ul style="text-align: left;">
                                        <li>Active</li>
                                        <li>Inactive</li>
                                    </ul>
                                </td>
                            </tr>
                            <tr class="TableStyle-Default-Table-Body-Body1">
                                <td style="text-align: left;" class="TableStyle-Default-Table-BodyE-Column1-Body1">
                                    <p class="table-text">Analytics Query</p>
                                </td>
                                <td style="text-align: left;" class="TableStyle-Default-Table-BodyD-Column1-Body1">
                                    <div class="content-wrapper">
                                        <p>Enter the analytics query in SQL format depending on the scenario for which the report is being generated.</p>
                                        <p>For example, a sample query has been displayed below:</p>
                                        <MadCap:codeSnippet>
                                            <MadCap:codeSnippetCopyButton aria-label="Copy" title="Copy to clipboard" />
                                            <MadCap:codeSnippetCaption>SQL</MadCap:codeSnippetCaption>
                                            <MadCap:codeSnippetBody MadCap:useLineNumbers="False" MadCap:lineNumberStart="1" MadCap:continue="False" xml:space="preserve" style="padding-left: 12px;padding-right: 16px;padding-top: 12px;padding-bottom: 12px;mc-code-lang: SQL;">select ev.ENTITLEMENT_VALUE,ev.ENTITLEMENTTYPEKEY from entitlement_values ev join entitlement_types et on et.ENTITLEMENTTYPEKEY = ev.ENTITLEMENTTYPEKEY join endpoints e on e.ENDPOINTKEY = et.ENDPOINTKEY where ev.ENTITLEMENTTYPEKEY=6 and ev.ENTITLEMENT_VALUEKEY='${entitlement_value.id}'</MadCap:codeSnippetBody>
                                        </MadCap:codeSnippet>
                                        <div class="confluence-information-macro confluence-information-macro-note conf-macro output-block">
                                            <div class="confluence-information-macro-body">
                                                <p>As few columns are displayed twice because of the query and option to select the column, following columns have been restricted for Non-ES to be passed.&#160;</p>
                                                <ul>
                                                    <li>status column, </li>
                                                    <li>comments column</li>
                                                </ul>
                                                <p>As a workaround, you can still pass status and column by specifying an alias for status or column in the query, which will still create and run the control. It will display only 1 column as desired for status and column. For example: </p>
                                                <MadCap:codeSnippet>
                                                    <MadCap:codeSnippetCopyButton aria-label="Copy" title="Copy to clipboard" />
                                                    <MadCap:codeSnippetCaption>SQL</MadCap:codeSnippetCaption>
                                                    <MadCap:codeSnippetBody MadCap:useLineNumbers="False" MadCap:lineNumberStart="1" MadCap:continue="False" xml:space="preserve" style="padding-left: 12px;padding-right: 16px;padding-top: 12px;padding-bottom: 12px;mc-code-lang: SQL;">select status as accountstatus from accounts;</MadCap:codeSnippetBody>
                                                </MadCap:codeSnippet>
                                                <p>In the above example, accountstatus is an alias used to fetch status. You can use any alias other than status.</p>
                                                <MadCap:codeSnippet>
                                                    <MadCap:codeSnippetCopyButton aria-label="Copy" title="Copy to clipboard" />
                                                    <MadCap:codeSnippetCaption>SQL</MadCap:codeSnippetCaption>
                                                    <MadCap:codeSnippetBody MadCap:useLineNumbers="False" MadCap:lineNumberStart="1" MadCap:continue="False" xml:space="preserve" style="padding-left: 12px;padding-right: 16px;padding-top: 12px;padding-bottom: 12px;mc-code-lang: SQL;">select comments as acccomments from accounts;   </MadCap:codeSnippetBody>
                                                </MadCap:codeSnippet>
                                                <p>In the above example, acccomments is an alias used to fetch the comments value. You can use any alias other than comments.&#160;</p>
                                            </div>
                                        </div>
                                        <p class="auto-cursor-target">You can define dynamic attributes during run-time.</p>
                                        <p class="auto-cursor-target">For more information, read&#160;defining dynamic attributes.</p>
                                    </div>
                                </td>
                            </tr>
                            <tr class="TableStyle-Default-Table-Body-Body1">
                                <td style="text-align: left;" colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1">
                                    <p class="table-text">Description</p>
                                </td>
                                <td style="text-align: left;" colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1">
                                    <p class="table-text">Enter the description for the analytic query.</p>
                                </td>
                            </tr>
                            <tr class="TableStyle-Default-Table-Body-Body1">
                                <td style="text-align: left;" colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1">
                                    <p class="table-text">External Connection</p>
                                </td>
                                <td style="text-align: left;" colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1">
                                    <p class="table-text">(Optional) Select the name of the external connection if it is connected through a DB connector. This is optional and is used in scenarios where the data is not on Saviynt's IGA database but is existing on a different DB. To fetch reports and display from a different customized DB, you need to first create a DB connection and then select the DB connection in External Connection.&#160;</p>
                                </td>
                            </tr>
                            <tr class="TableStyle-Default-Table-Body-Body1">
                                <td style="text-align: left;" colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1">
                                    <p class="table-text">Risk<span style="color: rgb(255,0,0);">*</span></p>
                                </td>
                                <td style="text-align: left;" colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1">
                                    <p style="text-align: left;" class="table-text">Select the priority of the risk.&#160;</p>
                                    <p style="text-align: left;" class="table-text">The following options are available to select:</p>
                                    <ul style="text-align: left;">
                                        <li>Low</li>
                                        <li>Medium</li>
                                        <li>High</li>
                                    </ul>
                                </td>
                            </tr>
                            <tr class="TableStyle-Default-Table-Body-Body1">
                                <td style="text-align: left;" colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1">
                                    <p class="table-text">Tags</p>
                                </td>
                                <td style="text-align: left;" colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1">
                                    <p class="table-text">Unique labels to easily segregate the reports.</p>
                                </td>
                            </tr>
                            <tr class="TableStyle-Default-Table-Body-Body1">
                                <td style="text-align: left;" colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1">
                                    <p class="table-text">Email Template</p>
                                </td>
                                <td style="text-align: left;" colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1">
                                    <p class="table-text">Select the relevant email template.</p>
                                    <p class="table-text">The email template being used to send out analytic report to the user. For more information on email templates, see&#160;<MadCap:xref href="../Chapter06-Configuring-EIC/Creating-and-Managing-Email-Templates.htm">Creating and Managing Email Templates</MadCap:xref>.</p>
                                </td>
                            </tr>
                            <tr class="TableStyle-Default-Table-Body-Body1">
                                <td style="text-align: left;" colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1">
                                    <p class="table-text">Recommendations</p>
                                </td>
                                <td style="text-align: left;" colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1">
                                    <p class="table-text">Select the appropriate recommendations (if any) for the analytics. You can provide any suggestions or recommended actions as best practices here.</p>
                                </td>
                            </tr>
                            <tr class="TableStyle-Default-Table-Body-Body1">
                                <td style="text-align: left;" colspan="1" class="TableStyle-Default-Table-BodyB-Column1-Body1">
                                    <p class="table-text">Executable Type</p>
                                </td>
                                <td style="text-align: left;" colspan="1" class="TableStyle-Default-Table-BodyA-Column1-Body1">
                                    <p class="table-text">Select the appropriate executable type.</p>
                                    <p class="table-text">The following options are available to select:</p>
                                    <ul>
                                        <li>Executable - Select Executable, if you just want to fetch and display the runtime analytics data.</li>
                                        <li>Preventative - Select Preventative, if you are creating a preventative analytical control and you want to use it in conjunction with <MadCap:xref href="../Chapter05-Managing-Policies/Creating-Entitlement-Update-Rules.htm">Creating Entitlement Update Rules</MadCap:xref>.</li>
                                    </ul>
                                </td>
                            </tr>
                        </tbody>
                    </table>
                </div>
            </li>
            <li>Click <strong>Submit</strong> to create the analytics.&#160;</li>
            <li>The <strong>Choose type for the fields selected</strong> window appears. Select the type for the fields selected and click <strong>Submit</strong>. The check box option is made available to select one or more columns while creating/updating control. The pop-up window displays all the column names with their relevant check boxes. You can select a maximum of 10 columns from <strong>Filterable</strong> to show in left filter and <strong>Visibility</strong> is used to show columns in the right data table. The relevant report is displayed with the filter option based on the check boxes&#160;selected.</li>
            <li>The following options are available:&#160;String,&#160;Number,&#160;Date</li>
            <li>
                <p class="auto-cursor-target">The runtime analytics configuration is created and the details are displayed in the following tabs.</p>
            </li>
        </ol>
        <br />
        <p class="auto-cursor-target"><b>Details Tab</b>
            <br />
        </p>
        <div class="table-wrap">
            <table class="TableStyle-Default-Table" style="width: 100%;mc-table-style: url('../Resources/TableStyles/Default-Table.css');" cellspacing="0">
                <col style="width: 140.0px;" class="TableStyle-Default-Table-Column-Column1" />
                <col style="width: 258.0px;" class="TableStyle-Default-Table-Column-Column1" />
                <thead>
                    <tr class="TableStyle-Default-Table-Head-Header1">
                        <th class="TableStyle-Default-Table-HeadE-Column1-Header1">Parameter</th>
                        <th class="TableStyle-Default-Table-HeadD-Column1-Header1">Description</th>
                    </tr>
                </thead>
                <tbody>
                    <tr class="TableStyle-Default-Table-Body-Body1">
                        <td style="text-align: left;" class="TableStyle-Default-Table-BodyE-Column1-Body1">
                            <p class="table-text">Analytics Name</p>
                        </td>
                        <td style="text-align: left;" class="TableStyle-Default-Table-BodyD-Column1-Body1">
                            <p class="table-text">Displays the appropriate analytics name.</p>
                        </td>
                    </tr>
                    <tr class="TableStyle-Default-Table-Body-Body1">
                        <td colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1">
                            <p class="table-text">Status</p>
                        </td>
                        <td colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1">
                            <p class="table-text">Displays the current status of the analytics.</p>
                        </td>
                    </tr>
                    <tr class="TableStyle-Default-Table-Body-Body1">
                        <td style="text-align: left;" class="TableStyle-Default-Table-BodyE-Column1-Body1">
                            <p class="table-text">Analytics Query</p>
                        </td>
                        <td style="text-align: left;" class="TableStyle-Default-Table-BodyD-Column1-Body1">
                            <p class="table-text">Displays the analytics query.</p>
                        </td>
                    </tr>
                    <tr class="TableStyle-Default-Table-Body-Body1">
                        <td style="text-align: left;" colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1">
                            <p class="table-text">Description</p>
                        </td>
                        <td style="text-align: left;" colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1">
                            <p class="table-text">Displays the analytics description.</p>
                        </td>
                    </tr>
                    <tr class="TableStyle-Default-Table-Body-Body1">
                        <td colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1">
                            <p class="table-text">Sub Category</p>
                        </td>
                        <td colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1">
                            <p class="table-text">Displays the subcategory name</p>
                        </td>
                    </tr>
                    <tr class="TableStyle-Default-Table-Body-Body1">
                        <td style="text-align: left;" colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1">
                            <p class="table-text">External Connection</p>
                        </td>
                        <td style="text-align: left;" colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1">
                            <p class="table-text">Displays the external connection name.</p>
                        </td>
                    </tr>
                    <tr class="TableStyle-Default-Table-Body-Body1">
                        <td style="text-align: left;" colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1">
                            <p class="table-text">Risk</p>
                        </td>
                        <td style="text-align: left;" colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1">
                            <p style="text-align: left;" class="table-text">Displays the severity of the risk.</p>
                        </td>
                    </tr>
                    <tr class="TableStyle-Default-Table-Body-Body1">
                        <td style="text-align: left;" colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1">
                            <p class="table-text">Tags</p>
                        </td>
                        <td style="text-align: left;" colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1">
                            <p class="table-text">Displays the tag(s) name.</p>
                        </td>
                    </tr>
                    <tr class="TableStyle-Default-Table-Body-Body1">
                        <td style="text-align: left;" colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1">
                            <p class="table-text">Email Template</p>
                        </td>
                        <td style="text-align: left;" colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1">
                            <p class="table-text">Displays the email template.</p>
                        </td>
                    </tr>
                    <tr class="TableStyle-Default-Table-Body-Body1">
                        <td style="text-align: left;" colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1">
                            <p class="table-text">Recommendations</p>
                        </td>
                        <td style="text-align: left;" colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1">
                            <p class="table-text">Displays the recommendation details.</p>
                        </td>
                    </tr>
                    <tr class="TableStyle-Default-Table-Body-Body1">
                        <td style="text-align: left;" colspan="1" class="TableStyle-Default-Table-BodyB-Column1-Body1">
                            <p class="table-text">Executable Type</p>
                        </td>
                        <td style="text-align: left;" colspan="1" class="TableStyle-Default-Table-BodyA-Column1-Body1">
                            <p class="table-text">Displays the executable type.</p>
                        </td>
                    </tr>
                </tbody>
            </table>
        </div>
        <p class="auto-cursor-target"><strong>Submission Options</strong>: This is the step of the analytics process. The following options are available to select:</p>
        <ul>
            <li><strong>Create Similar Analytics</strong> - Click this option to create similar analytics.</li>
            <li><strong>Edit</strong> - Click this option to edit the existing analytics details. You can edit the required parameters and update.</li>
            <li><strong>Delete</strong> - Click this option to delete the analytics.</li>
        </ul>
        <p class="auto-cursor-target"><b>History Tab</b>
            <br />This tab displays the history details in the following columns:</p>
        <table class="TableStyle-Default-Table" style="width: 100%;mc-table-style: url('../Resources/TableStyles/Default-Table.css');" cellspacing="0">
            <col style="width: 104.0px;" class="TableStyle-Default-Table-Column-Column1" />
            <col style="width: 230.0px;" class="TableStyle-Default-Table-Column-Column1" />
            <thead>
                <tr class="TableStyle-Default-Table-Head-Header1">
                    <th class="TableStyle-Default-Table-HeadE-Column1-Header1">Column</th>
                    <th class="TableStyle-Default-Table-HeadD-Column1-Header1">Description</th>
                </tr>
            </thead>
            <tbody>
                <tr class="TableStyle-Default-Table-Body-Body1">
                    <td style="text-align: left;" class="TableStyle-Default-Table-BodyE-Column1-Body1">
                        <p class="table-text">Updated By</p>
                    </td>
                    <td style="text-align: left;" class="TableStyle-Default-Table-BodyD-Column1-Body1">
                        <p class="table-text">Displays the name of the user who updated the analytic details.</p>
                    </td>
                </tr>
                <tr class="TableStyle-Default-Table-Body-Body1">
                    <td colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1">
                        <p class="table-text">Modified On</p>
                    </td>
                    <td colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1">
                        <p class="table-text">Displays the date when the analytic is modified.</p>
                    </td>
                </tr>
                <tr class="TableStyle-Default-Table-Body-Body1">
                    <td style="text-align: left;" class="TableStyle-Default-Table-BodyE-Column1-Body1">
                        <p class="table-text">Operation</p>
                    </td>
                    <td style="text-align: left;" class="TableStyle-Default-Table-BodyD-Column1-Body1">
                        <p class="table-text">Displays the activity performed.</p>
                    </td>
                </tr>
                <tr class="TableStyle-Default-Table-Body-Body1">
                    <td style="text-align: left;" colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1">
                        <p class="table-text">Field</p>
                    </td>
                    <td style="text-align: left;" colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1">
                        <p class="table-text">Displays the field name where the change is made.</p>
                    </td>
                </tr>
                <tr class="TableStyle-Default-Table-Body-Body1">
                    <td colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1">
                        <p class="table-text">Old Value</p>
                    </td>
                    <td colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1">
                        <p class="table-text">Displays the old value whether it is edited, modified or deleted.</p>
                    </td>
                </tr>
                <tr class="TableStyle-Default-Table-Body-Body1">
                    <td style="text-align: left;" colspan="1" class="TableStyle-Default-Table-BodyB-Column1-Body1">
                        <p class="table-text">New Value</p>
                    </td>
                    <td style="text-align: left;" colspan="1" class="TableStyle-Default-Table-BodyA-Column1-Body1">
                        <p class="table-text">Displays the new value.</p>
                    </td>
                </tr>
            </tbody>
        </table>
        <ul>
            <li>
                <p style="text-align: left;">After the analytics is created, you can run the analytics using the following options available under <strong>Run.</strong></p>
                <ul style="text-align: left;">
                    <li><strong>Dry Run</strong> - The newly created/edited analytics will be run on a test basis, but the results are not stored in the run history.</li>
                    <li><strong>Run Now</strong> -&#160;The newly created/edited analytics will be run and the results are stored under run history.</li>
                    <li><strong>Run History</strong> - Displays the previously run analytics history and results from multiple runs can be compared.</li>
                </ul>
            </li>
            <li>
                <p>The newly created analytics will run and displays the results. You can filter or search based on the search parameters.</p>
            </li>
        </ul>
        <h2 id="CreatingRuntimeAnalyticsControl-RetrievingRunTimeAnalyticsControlParametersfromRESTAPI:">Retrieving Run Time Analytics Control Parameters from REST API:</h2>
        <p>You can now retrieve the&#160;parameters of a run-time analytic control, both Elastic Search and Database-based control data via a REST API call. To fetch the dynamic attribute, it is mandatory to add the analytics type (Elastic Search/Database) with either id or analytics name. If both id and name are present, API will consider the id.&#160;</p>
        <p>The table below briefs about the different types of JSON inputs with the response:</p>
        <table class="TableStyle-Default-Table" style="width: 100%;mc-table-style: url('../Resources/TableStyles/Default-Table.css');" cellspacing="0">
            <col class="TableStyle-Default-Table-Column-Column1" />
            <col class="TableStyle-Default-Table-Column-Column1" />
            <col class="TableStyle-Default-Table-Column-Column1" />
            <thead>
                <tr class="TableStyle-Default-Table-Head-Header1">
                    <th class="TableStyle-Default-Table-HeadE-Column1-Header1">JSON Input</th>
                    <th class="TableStyle-Default-Table-HeadE-Column1-Header1">JSON&#160;Response</th>
                    <th class="TableStyle-Default-Table-HeadD-Column1-Header1">Error&#160;Code</th>
                </tr>
            </thead>
            <tbody>
                <tr class="TableStyle-Default-Table-Body-Body1">
                    <td colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1">
                        <p class="table-text">{"analyticstype":"DB","id":"936","analyticsname":"RuntimeAPI"}</p>
                    </td>
                    <td colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1">
                        <p class="table-text">{"msg:"success"}</p>
                    </td>
                    <td colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1">
                        <p class="table-text">0</p>
                    </td>
                </tr>
                <tr class="TableStyle-Default-Table-Body-Body1">
                    <td class="TableStyle-Default-Table-BodyE-Column1-Body1">
                        <p class="table-text">{"analyticstype":"","id":"","analyticsname":""}</p>
                    </td>
                    <td class="TableStyle-Default-Table-BodyE-Column1-Body1">
                        <p class="table-text">{"msg": "Please enter analytics type and analytics id or name"}</p>
                    </td>
                    <td colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1">
                        <p class="table-text">1</p>
                    </td>
                </tr>
                <tr class="TableStyle-Default-Table-Body-Body1">
                    <td class="TableStyle-Default-Table-BodyE-Column1-Body1">
                        <div class="content-wrapper">
                            <p class="auto-cursor-target">{"analyticstype":"ES","analyticsname":"RuntimeAPI"}</p>
                        </div>
                    </td>
                    <td class="TableStyle-Default-Table-BodyE-Column1-Body1">
                        <p class="table-text">{"msg": "No such analytics controls found. Please provide valid inputs"}</p>
                    </td>
                    <td colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1">
                        <p class="table-text">1</p>
                    </td>
                </tr>
                <tr class="TableStyle-Default-Table-Body-Body1">
                    <td colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1">
                        <p class="table-text">{"analyticstype":"DB}</p>
                    </td>
                    <td colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1">
                        <p class="table-text">{"msg": "Please provide analytics name or id"}</p>
                    </td>
                    <td colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1">
                        <p class="table-text">1</p>
                    </td>
                </tr>
                <tr class="TableStyle-Default-Table-Body-Body1">
                    <td colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1">
                        <p class="table-text">{"id":"936"}</p>
                    </td>
                    <td colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1">
                        <p class="table-text">{"msg": "Please provide analytics type"}</p>
                    </td>
                    <td colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1">
                        <p class="table-text">1</p>
                    </td>
                </tr>
                <tr class="TableStyle-Default-Table-Body-Body1">
                    <td colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1">
                        <p class="table-text">{"analyticsname":"RuntimeAPI"}</p>
                    </td>
                    <td colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1">
                        <p class="table-text">{"msg": "Please provide analytics type"}</p>
                    </td>
                    <td colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1">
                        <p class="table-text">1</p>
                    </td>
                </tr>
                <tr class="TableStyle-Default-Table-Body-Body1">
                    <td colspan="1" class="TableStyle-Default-Table-BodyB-Column1-Body1">
                        <p class="table-text">{"analyticstype":"DB","analyticsname":"RuntimeTest"}</p>
                    </td>
                    <td colspan="1" class="TableStyle-Default-Table-BodyB-Column1-Body1">
                        <p class="table-text">{"msg": "No dynamic attributes found"}</p>
                    </td>
                    <td colspan="1" class="TableStyle-Default-Table-BodyA-Column1-Body1">
                        <p class="table-text">0</p>
                    </td>
                </tr>
            </tbody>
        </table>
        <p>The following query needs to be run before using the below JSON:&#160;</p>
        <MadCap:codeSnippet>
            <MadCap:codeSnippetCopyButton aria-label="Copy" title="Copy to clipboard" />
            <MadCap:codeSnippetBody MadCap:useLineNumbers="False" MadCap:lineNumberStart="1" MadCap:continue="False" xml:space="preserve" style="padding-left: 12px;padding-right: 16px;padding-top: 12px;padding-bottom: 12px;mc-code-lang: PlainText;">INSERT INTO REQUESTMAP (AUTHTYPE,CONFIGATTRIBUTE,DESCRIPTION,PARENTMENU,PARENTMENUORDER,URL,LANDINGPAGE,HTTPMETHOD) VALUES ('webservice_api','ROLE_ADMIN','WEBSERVICE',0,0,'/api/v5/fetchControlAttributes',0,NULL);   </MadCap:codeSnippetBody>
        </MadCap:codeSnippet>
        <p><strong>Sample JSON</strong>
        </p>
        <p>The JSON below illustrates the response when proper input is given.</p>
        <p>Sample Input:</p>
        <MadCap:codeSnippet>
            <MadCap:codeSnippetCopyButton aria-label="Copy" title="Copy to clipboard" />
            <MadCap:codeSnippetCaption>SQL</MadCap:codeSnippetCaption>
            <MadCap:codeSnippetBody MadCap:useLineNumbers="False" MadCap:lineNumberStart="1" MadCap:continue="False" xml:space="preserve" style="padding-left: 12px;padding-right: 16px;padding-top: 12px;padding-bottom: 12px;mc-code-lang: SQL;">{"analyticstype":"ES","id":"594","analyticsname":"InTest"}   </MadCap:codeSnippetBody>
        </MadCap:codeSnippet>
        <p>Sample Response:</p>
        <MadCap:codeSnippet>
            <MadCap:codeSnippetCopyButton aria-label="Copy" title="Copy to clipboard" />
            <MadCap:codeSnippetCaption>JSON</MadCap:codeSnippetCaption>
            <MadCap:codeSnippetBody MadCap:useLineNumbers="False" MadCap:lineNumberStart="1" MadCap:continue="False" xml:space="preserve" style="padding-left: 12px;padding-right: 16px;padding-top: 12px;padding-bottom: 12px;mc-code-lang: PlainText;">{
  "msg": "Success",
  "attributesList": [
    {
      "attributeKey": "4",
      "attributeName": "A1",
      "attributeLabel": "A1 Label",
      "format": "String",
      "attributeValue": "",
      "attributeDefaultValue": "Default String",
      "orderIndex": "0"
    },
    {
      "attributeKey": "5",
      "attributeName": "A2",
      "attributeLabel": "A2 Label",
      "format": "Number",
      "attributeValue": "",
      "attributeDefaultValue": "Default String",
      "orderIndex": "1"
    },
    {
      "attributeKey": "6",
      "attributeName": "A3",
      "attributeLabel": "A3 Label",
      "format": "Single Select SQL Query",
      "attributeValue": "select distinct city from users",
      "attributeDefaultValue": "select distinct city from users where userkey=1",
      "orderIndex": "2"
    }
  ]
	  "errorcode":"0"
}
   </MadCap:codeSnippetBody>
        </MadCap:codeSnippet>
        <p class="auto-cursor-target"><strong>Headers</strong>:</p>
        <p class="auto-cursor-target"><strong>Authorization&#160; &#160; &#160; &#160; &#160; &#160; &#160;</strong> Bearer&#160;{{token}}</p>
        <p class="auto-cursor-target"><strong>Content-type</strong>&#160; &#160; &#160; &#160; &#160; &#160; &#160; application/x-www-form-urlencoded</p>
        <p class="auto-cursor-target">
            <img src="../Resources/Images/run analytics controls.png" style="width: 873px;height: 534px;border-left-style: solid;border-left-width: 1px;border-right-style: solid;border-right-width: 1px;border-top-style: solid;border-top-width: 1px;border-bottom-style: solid;border-bottom-width: 1px;" />
        </p>
        <p>&#160;</p>
    </body>
</html>